package actions

import (
	"github.com/gin-gonic/gin"
    "{{.ModuleName}}/utils/basic"
    "{{.ModuleName}}/utils/log"
)

var HandlersFuncRoutes map[string]gin.HandlerFunc = make(map[string]gin.HandlerFunc)

func init() {
{{- range .ActionFunctions}}
    // func {{.FuncName}}(ctx *gin.Context, param *{{.ParamStruct.ParamStructName}}) (resp *basic.Response)
	HandlersFuncRoutes["{{.ActionName}}"] = {{.FuncName}}Handler
{{- end}}
}

{{- range .ActionFunctions}}
type {{.ParamStruct.ParamStructName}} struct {
	{{- range .ParamStruct.ParamFields}}
	{{.ParamNameCamel}} {{.ParamType}} `json:"{{.ParamName}}" form:"{{.ParamName}}" binding:"{{.ParamBinding}}"`
	{{- end}}
}

func {{.FuncName}}Handler(ctx *gin.Context) {
    var resp *basic.Response  

	param := &{{.ParamStruct.ParamStructName}}{}
	err := ctx.ShouldBind(param)
	if err != nil {
        log.Println(err)
		resp = resp.Error(basic.ErrParamParse)
		return
	}
 
    resp = {{.FuncName}}(ctx, param)
	if resp == nil {
		resp = resp.Error(basic.ErrRespNotNil)
	}
	ctx.JSON(200, resp)
}
{{end}}